module EasySitemap
  class Generator

    def initialize(entities_scope, options = {})
      @entities_scope = entities_scope
      @options = options
    end

    def to_xml
      builder = Nokogiri::XML::Builder.new do |xml|
        xml.urlset do
          @entities_scope.find_each(batch_size: 1) do |entity|
            xml.url do
              xml.loc url(entity)
              if entity.respond_to?(:updated_at)
                xml.lastmod entity.updated_at
              elsif entity.respond_to?(:updated_on)
                xml.lastmod entity.updated_on
              end
            end
          end
        end
      end
      builder.to_xml
    end

    protected

    def url(entity)
      u = [@options[:host] || "http://localhost:3000"]
      u << case entity
           when Issue
             "issues"
           end
      u << entity.id
      u.join("/")
    end

  end
end
