begin
  require 'rspec/core/rake_task'

  namespace :easy_sitemap do
    desc 'Runs rspec tests'
    RSpec::Core::RakeTask.new(:spec) do |task, _task_args|
      args = []
      args << '--require' << Ryspec::Engine.root.join('spec/spec_helper')

      task.rspec_opts = args
      task.pattern = EasySitemap::Engine.root.join('spec/**/*_spec.rb')
    end

    desc <<-END_DESC
    Generate sitemap from DB

    Example:
      bundle exec rails easy_sitemap:generate filename="path_or_file_name"
    END_DESC
    task :generate => :environment do
      EasySitemap.create(ENV['filename'].presence || 'sitemap.xml')
    end

  end
rescue StandardError, LoadError
  # Ignore when `ryspec` gem missing
end
